#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <serial.h>
#include <time.h>
#define DRIVERNAME  "c64-up2400.ser"

static const struct ser_params serialParams = {
    SER_BAUD_2400,      /* Baudrate */
    SER_BITS_8,         /* Number of data bits */
    SER_STOP_1,         /* Number of stop bits */
    SER_PAR_NONE,       /* Parity setting */
    SER_HS_NONE         /* Type of handshake to use */
};

unsigned CURRENT_MINUTE, CURRENT_SECOND, CURRENT_TICK, CLOCK_OFFSET, pause_until = 0;
const int DTA_OFFSET = 11;
char clock_msg[32];
unsigned char XSize, YSize;
long cur_data_idx = 11, data_in = 0;

void doClock() {
	CURRENT_TICK = (unsigned) (clock() / CLOCKS_PER_SEC) - CLOCK_OFFSET;
	CURRENT_SECOND = CURRENT_TICK % 60;
	CURRENT_MINUTE = CURRENT_TICK / 60;
}

char msg[64];
void drawChar(char c)
{
	cputcxy((cur_data_idx % XSize), (cur_data_idx / XSize), '[');
	cur_data_idx++;
	cputcxy((cur_data_idx % XSize), (cur_data_idx / XSize), c);
	cur_data_idx++;
	cputsxy((cur_data_idx % XSize), (cur_data_idx / XSize), "] ");
	cur_data_idx+=2;
	
	sprintf(msg, "in: %4d", c);
	cputsxy(0,20,msg);
}

int main (void)
{
	int requested = 0, receiving = 0, looping = 1;
	char c;
	
	/* Clear the screen, put cursor in upper left corner */
    clrscr();
    textcolor(COLOR_WHITE);
    bordercolor(COLOR_BLACK);
    bgcolor(COLOR_BLACK);

    /* Ask for the screen size */
    screensize (&XSize, &YSize);

	clrscr();
	puts("C64 serial:");

	// Load driver
	ser_load_driver(DRIVERNAME);

	// Open port
	ser_open(&serialParams);

	// Enable serial
	ser_ioctl(1, NULL);

	while (looping == 1) {	
		doClock();
		sprintf(clock_msg, 
				(CURRENT_MINUTE < 10 && CURRENT_SECOND < 10 
					? "[0%d:0%d] Received:%Ld"
					: (CURRENT_SECOND < 10 ? "[%d:0%d] Received:%Ld"
										   : CURRENT_MINUTE < 10 ? "[0%d:%d] Received:%Ld" : "[%d:%d] Received:%Ld")), 
				CURRENT_MINUTE, CURRENT_SECOND, data_in);
		textcolor(COLOR_YELLOW);
		cputsxy(0, YSize - 1, clock_msg);
	
		if (ser_get(&c) != SER_ERR_NO_DATA) {
			//process data inbound.
			textcolor(COLOR_GREEN);
			drawChar(c);
			data_in++;
		}
		
		if (kbhit()) {
			c = cgetc();
			if (c == 'q') looping = 0;
		}
	}

	return EXIT_SUCCESS;
}